            #GIT_CMT=8572e4c814343b4f76dce719a803c5960e6ee15b

# Resulting binary formats we want from iPXE
%global formats rom

# 0x1022 0x2000 - 79c970 [PCnet32 LANCE]
# 0x8086 0x100e - 82540EM Gigabit Ethernet Controller
# 0x8086 0x10d3 - e1000 PCIe
# 0x8086 0x10ed - 82599 Ethernet Controller Virtual Function
# 0x8086 0x10f8 - 82599 10 Gigabit Dual Port Backplane Connection
# 0x8086 0x10f9 - 82599 10 Gigabit Dual Port Network Connection
# 0x8086 0x10fb - 82599ES 10-Gigabit SFI/SFP+ Network Connection
# 0x8086 0x10fc - 82599 10 Gigabit Dual Port Network Connection
# 0x8086 0x1515 - X540 Ethernet Controller Virtual Function
# 0x8086 0x1528 - Ethernet Controller 10-Gigabit X540-AT2Ethernet Controller 10-Gigabit X540-AT2
# 0x8086 0x1560 - Ethernet Controller X540
# 0x10ec 0x8139 - RTL-8100/8101L/8139 PCI Fast Ethernet Adapter
# 0x10ec 0x8169 - RTL8169 PCI Gigabit Ethernet Controller
# 0x1af4 0x1000 - Virtio network device

%global qemuroms 10222000 8086100e 808610d3 808610ed 808610f8 808610f9 808610fb 808610fc 80861515 80861528 80861560 10ec8139 10ec8169 1af41000

%global ocibins intelx snp

%global otherbins ipxe realtek intel tg3 bnx2 hermon

%global dbg_opt scsi:3,iscsi:3,bnx2:3,snp:3,intel:3,intelx:3,tg3:3,virtio-net:3,efi_pxe:3,efi_driver:3,dhcp:3,pxe_cmd:3,tftp:3,http:3,https:3

# We only build the ROMs if on an x86 build host. The resulting
# binary RPM will be noarch, so other archs will still be able
# to use the binary ROMs.
#
# We do cross-compilation for 32->64-bit, but not for other arches
# because EDK II does not support big-endian hosts.
%global buildarches %{ix86} x86_64

# debugging firmwares does not go the same way as a normal program.
# moreover, all architectures providing debuginfo for a single noarch
# package is currently clashing in koji, so don't bother.
%global debug_package %{nil}

# Upstream don't do "releases" :-( So we're going to use the date
# as the version, and a GIT hash as the release. Generate new GIT
# snapshots using the folowing commands:
#
# $ hash=`git log -1 --format='%h'`
# $ date=`git log -1 --format='%cd' --date=short | tr -d -`
# $ git archive --prefix ipxe-${date}-git${hash}/ HEAD | xz -7e > ipxe-${date}-git${hash}.tar.xz
#
# And then change these two:

%global hash b5e0b507
%global date 20171112

Name:    ipxe
Version: %{date}
Release:    1.el7
Summary: A network boot loader

Group:   System Environment/Base
License: GPLv2 with additional permissions and BSD
URL:     http://ipxe.org/

Source0: ipxe-20171112.tar.bz2

# Enable IPv6 for qemu's config
# Sent upstream: http://lists.ipxe.org/pipermail/ipxe-devel/2015-November/004494.html

BuildRequires: perl
BuildRequires: perl-Getopt-Long
BuildRequires: syslinux
BuildRequires: mtools
BuildRequires: mkisofs
BuildRequires: edk2-tools
BuildRequires: xz-devel

BuildRequires: binutils-devel
BuildRequires: binutils-x86_64-linux-gnu gcc-x86_64-linux-gnu

Obsoletes: gpxe <= 1.0.1

%package bootimgs
Summary: Network boot loader images in bootable USB, CD, floppy and GRUB formats
Group:   Development/Tools
BuildArch: noarch
Obsoletes: gpxe-bootimgs <= 1.0.1

%package bootimgs-debug
Summary: Network boot loader images in bootable USB, CD, floppy and GRUB formats with debug enabled
Group:   Development/Tools
BuildArch: noarch
Obsoletes: gpxe-bootimgs <= 1.0.1

%package roms
Summary: Network boot loader roms in .rom format
Group:  Development/Tools
Requires: %{name}-roms-qemu = %{version}-%{release}
BuildArch: noarch
Obsoletes: gpxe-roms <= 1.0.1

%package roms-debug
Summary: Network boot loader roms in .rom format with debug enabled.
Group:  Development/Tools
Requires: %{name}-roms-qemu = %{version}-%{release}
BuildArch: noarch
Obsoletes: gpxe-roms <= 1.0.1

%package roms-qemu
Summary: Network boot loader roms supported by QEMU, .rom format
Group:  Development/Tools
BuildArch: noarch
Obsoletes: gpxe-roms-qemu <= 1.0.1

%description bootimgs
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the iPXE boot images in USB, CD, floppy, and PXE
UNDI formats.

%description bootimgs-debug
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the iPXE boot images in USB, CD, floppy, and PXE
UNDI formats with debug enabled.

%description roms
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the iPXE roms in .rom format.


%description roms-debug
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the iPXE roms in .rom format with debug enabled.


%description roms-qemu
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

This package contains the iPXE ROMs for devices emulated by QEMU, in
.rom format.

%description
iPXE is an open source network bootloader. It provides a direct
replacement for proprietary PXE ROMs, with many extra features such as
DNS, HTTP, iSCSI, etc.

%prep
%setup -q -n %{name}-%{version}


%build
%ifarch %{buildarches}
cd src
sed -i s/#GIT#/%hash/ *.ipxe

# ath9k drivers are too big for an Option ROM, and ipxe devs say it doesn't
# make sense anyways
# http://lists.ipxe.org/pipermail/ipxe-devel/2012-March/001290.html
rm -rf drivers/net/ath/ath9k

make_ipxe() {
    make %{?_smp_mflags} \
        NO_WERROR=1 V=1 \
        GITVERSION=%{hash} \
        CROSS_COMPILE=x86_64-linux-gnu- \
        "$@"
}

# Because building the debug package was not implemented, doing this as per
# our requirement. It may have some duplicate work here, but should not affect
# the final product.

make all DEBUG="%{dbg_opt}"
mv bin/undionly.kpxe bin/undionly-debug.kpxe
mv bin/ipxe.iso bin/ipxe-debug.iso
mv bin/ipxe.usb bin/ipxe-debug.usb
mv bin/ipxe.dsk bin/ipxe-debug.dsk
mv bin/ipxe.lkrn bin/ipxe-debug.lkrn
ls bin/*rom |while read a
do
        file=`basename $a|cut -f1 -d "."`
        ext=`basename $a|cut -f2 -d "."`
        mv bin/$file.$ext bin/$file-debug.$ext
done;

# for oci

for oci in %ocibins; do
    make bin-x86_64-efi/${oci}.efi EMBED=embed-bm.ipxe DEBUG="%{dbg_opt}"
    mv bin-x86_64-efi/${oci}.efi bin-x86_64-efi/${oci}-debug.efi
    make bin-x86_64-efi/${oci}.efi EMBED=embed-bm.ipxe
done

# Make qemurom
for rom in %qemuroms; do
   make bin/${rom}.rom bin-x86_64-efi/${rom}.efidrv \
       bin-x86_64-efi/${rom}.efirom EMBED=embed-bm.ipxe \
       DEBUG="%{dbg_opt}"
   mv bin/${rom}.rom bin-x86_64-efi/${rom}-debug.rom
   mv bin-x86_64-efi/${rom}.efidrv bin-x86_64-efi/${rom}-debug.efidrv
   mv bin-x86_64-efi/${rom}.efirom bin-x86_64-efi/${rom}-debug.rom
done

# Make other modules that may be useful

for other in %otherbins; do
    make bin-x86_64-efi/${other}.efi EMBED=embed-bm.ipxe DEBUG="%{dbg_opt}"
    mv bin-x86_64-efi/${other}.efi bin-x86_64-efi/${other}-debug.efi
    make bin-x86_64-efi/${other}.efi EMBED=embed-bm.ipxe
done

# Back to the original file

make_ipxe bin-i386-efi/ipxe.efi bin-x86_64-efi/ipxe.efi

make_ipxe ISOLINUX_BIN=/usr/share/syslinux/isolinux.bin \
    bin/undionly.kpxe bin/ipxe.{dsk,iso,usb,lkrn} \
    allroms

# build roms with efi support for qemu
mkdir bin-combined
for rom in %{qemuroms}; do
  make_ipxe EMBED=embed-bm.ipxe bin/${rom}.rom
  make_ipxe EMBED=embed-bm.ipxe bin-i386-efi/${rom}.efidrv
  make_ipxe EMBED=embed-bm.ipxe bin-x86_64-efi/${rom}.efidrv
  vid="0x${rom%%????}"
  did="0x${rom#????}"
  EfiRom -f "$vid" -i "$did" --pci23 \
         -b  bin/${rom}.rom \
         -ec bin-i386-efi/${rom}.efidrv \
         -ec bin-x86_64-efi/${rom}.efidrv \
         -o  bin-combined/${rom}.rom
  EfiRom -d  bin-combined/${rom}.rom
done

%endif

%install
%ifarch %{buildarches}
mkdir -p %{buildroot}/%{_datadir}/%{name}/
mkdir -p %{buildroot}/%{_datadir}/%{name}.efi/
pushd src/bin/

cp -a undionly.kpxe ipxe.{iso,usb,dsk,lkrn} %{buildroot}/%{_datadir}/%{name}/

for fmt in %{formats};do
 for img in *.${fmt};do
      if [ -e $img ]; then
   cp -a $img %{buildroot}/%{_datadir}/%{name}/
   echo %{_datadir}/%{name}/$img >> ../../${fmt}.list
  fi
 done
done
popd

cp -a src/bin-i386-efi/ipxe.efi %{buildroot}/%{_datadir}/%{name}/ipxe-i386.efi
for efi in %{ocibins} %{otherbins}; do
    cp -a src/bin-x86_64-efi/${efi}.efi %{buildroot}/%{_datadir}/%{name}/${efi}-x86_64.efi
    cp -a src/bin-x86_64-efi/${efi}-debug.efi %{buildroot}/%{_datadir}/%{name}/${efi}-debug-x86_64.efi
done

# the roms supported by qemu will be packaged separatedly
# remove from the main rom list and add them to qemu.list
for fmt in rom ;do
 for rom in %{qemuroms} ; do
  sed -i -e "/\/${rom}.${fmt}/d" ${fmt}.list
  echo %{_datadir}/%{name}/${rom}.${fmt} >> qemu.${fmt}.list
 done
done
for rom in %{qemuroms}; do
  cp src/bin-combined/${rom}.rom %{buildroot}/%{_datadir}/%{name}.efi/
  echo %{_datadir}/%{name}.efi/${rom}.rom >> qemu.rom.list
done
%endif
# Just remove the debug roms from rom.list
sed -i "/\-debug\./d" rom.list

%ifarch %{buildarches}
%files bootimgs
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/ipxe.iso
%{_datadir}/%{name}/ipxe.usb
%{_datadir}/%{name}/ipxe.dsk
%{_datadir}/%{name}/ipxe.lkrn
%{_datadir}/%{name}/ipxe-i386.efi
%{_datadir}/%{name}/ipxe-x86_64.efi
%{_datadir}/%{name}/bnx2-x86_64.efi
%{_datadir}/%{name}/hermon-x86_64.efi
%{_datadir}/%{name}/intel-x86_64.efi
%{_datadir}/%{name}/intelx-x86_64.efi
%{_datadir}/%{name}/realtek-x86_64.efi
%{_datadir}/%{name}/snp-x86_64.efi
%{_datadir}/%{name}/tg3-x86_64.efi
%{_datadir}/%{name}/undionly.kpxe
%doc COPYING COPYING.GPLv2 COPYING.UBDL

%files bootimgs-debug
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*-debug-x86_64.efi
%doc COPYING COPYING.GPLv2 COPYING.UBDL

%files roms -f rom.list
%dir %{_datadir}/%{name}
%doc COPYING COPYING.GPLv2 COPYING.UBDL

%files roms-debug
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/*-debug.rom
%doc COPYING COPYING.GPLv2 COPYING.UBDL

%files roms-qemu -f qemu.rom.list
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}.efi
%doc COPYING COPYING.GPLv2 COPYING.UBDL
%endif

%changelog
* Tue Mar 6 2018 Marcos Matsunaga <Marcos.Matsunaga@oracle.com> - 20171112-1.el7
- BUILDINFO: commit=8572e4c814343b4f76dce719a803c5960e6ee15b
- ipxe spec: Fix %prep to be compatible with autobuild

